import { createDraftOrder as publicCreateDraftOrder, createEmptyDraftOrder as publicCreateEmptyDraftOrder, addLineItemsToDraftOrder as publicAddLineItemsToDraftOrder, updateLineItems as publicUpdateLineItems, setDiscounts as publicSetDiscounts, createCustomDiscounts as publicCreateCustomDiscounts, deleteCustomDiscounts as publicDeleteCustomDiscounts, setAdditionalFees as publicSetAdditionalFees, createCustomAdditionalFees as publicCreateCustomAdditionalFees, deleteCustomAdditionalFees as publicDeleteCustomAdditionalFees, setShippingInfo as publicSetShippingInfo, setBuyerInfo as publicSetBuyerInfo, setRecipientInfo as publicSetRecipientInfo, setBillingInfo as publicSetBillingInfo, getDraftOrder as publicGetDraftOrder, getOrderDraftabilityStatus as publicGetOrderDraftabilityStatus, commitDraftOrder as publicCommitDraftOrder, createOrderFromDraft as publicCreateOrderFromDraft, deleteDraftOrder as publicDeleteDraftOrder, queryDraftOrders as publicQueryDraftOrders, updateExtendedFields as publicUpdateExtendedFields, setTaxExemption as publicSetTaxExemption, setBusinessLocation as publicSetBusinessLocation } from './ecom-v1-draft-order-draft-orders.public.js';
import { createEventModule } from '@wix/sdk-runtime/event-definition-modules';
import { BuildRESTFunction, MaybeContext } from '@wix/sdk-types';
import { onDraftOrderCreated as publicOnDraftOrderCreated } from './ecom-v1-draft-order-draft-orders.public.js';
import { onDraftOrderDeleted as publicOnDraftOrderDeleted } from './ecom-v1-draft-order-draft-orders.public.js';
import { onDraftOrderUpdated as publicOnDraftOrderUpdated } from './ecom-v1-draft-order-draft-orders.public.js';
export declare const createDraftOrder: MaybeContext<BuildRESTFunction<typeof publicCreateDraftOrder> & typeof publicCreateDraftOrder>;
export declare const createEmptyDraftOrder: MaybeContext<BuildRESTFunction<typeof publicCreateEmptyDraftOrder> & typeof publicCreateEmptyDraftOrder>;
export declare const addLineItemsToDraftOrder: MaybeContext<BuildRESTFunction<typeof publicAddLineItemsToDraftOrder> & typeof publicAddLineItemsToDraftOrder>;
export declare const updateLineItems: MaybeContext<BuildRESTFunction<typeof publicUpdateLineItems> & typeof publicUpdateLineItems>;
export declare const setDiscounts: MaybeContext<BuildRESTFunction<typeof publicSetDiscounts> & typeof publicSetDiscounts>;
export declare const createCustomDiscounts: MaybeContext<BuildRESTFunction<typeof publicCreateCustomDiscounts> & typeof publicCreateCustomDiscounts>;
export declare const deleteCustomDiscounts: MaybeContext<BuildRESTFunction<typeof publicDeleteCustomDiscounts> & typeof publicDeleteCustomDiscounts>;
export declare const setAdditionalFees: MaybeContext<BuildRESTFunction<typeof publicSetAdditionalFees> & typeof publicSetAdditionalFees>;
export declare const createCustomAdditionalFees: MaybeContext<BuildRESTFunction<typeof publicCreateCustomAdditionalFees> & typeof publicCreateCustomAdditionalFees>;
export declare const deleteCustomAdditionalFees: MaybeContext<BuildRESTFunction<typeof publicDeleteCustomAdditionalFees> & typeof publicDeleteCustomAdditionalFees>;
export declare const setShippingInfo: MaybeContext<BuildRESTFunction<typeof publicSetShippingInfo> & typeof publicSetShippingInfo>;
export declare const setBuyerInfo: MaybeContext<BuildRESTFunction<typeof publicSetBuyerInfo> & typeof publicSetBuyerInfo>;
export declare const setRecipientInfo: MaybeContext<BuildRESTFunction<typeof publicSetRecipientInfo> & typeof publicSetRecipientInfo>;
export declare const setBillingInfo: MaybeContext<BuildRESTFunction<typeof publicSetBillingInfo> & typeof publicSetBillingInfo>;
export declare const getDraftOrder: MaybeContext<BuildRESTFunction<typeof publicGetDraftOrder> & typeof publicGetDraftOrder>;
export declare const getOrderDraftabilityStatus: MaybeContext<BuildRESTFunction<typeof publicGetOrderDraftabilityStatus> & typeof publicGetOrderDraftabilityStatus>;
export declare const commitDraftOrder: MaybeContext<BuildRESTFunction<typeof publicCommitDraftOrder> & typeof publicCommitDraftOrder>;
export declare const createOrderFromDraft: MaybeContext<BuildRESTFunction<typeof publicCreateOrderFromDraft> & typeof publicCreateOrderFromDraft>;
export declare const deleteDraftOrder: MaybeContext<BuildRESTFunction<typeof publicDeleteDraftOrder> & typeof publicDeleteDraftOrder>;
export declare const queryDraftOrders: MaybeContext<BuildRESTFunction<typeof publicQueryDraftOrders> & typeof publicQueryDraftOrders>;
export declare const updateExtendedFields: MaybeContext<BuildRESTFunction<typeof publicUpdateExtendedFields> & typeof publicUpdateExtendedFields>;
export declare const setTaxExemption: MaybeContext<BuildRESTFunction<typeof publicSetTaxExemption> & typeof publicSetTaxExemption>;
export declare const setBusinessLocation: MaybeContext<BuildRESTFunction<typeof publicSetBusinessLocation> & typeof publicSetBusinessLocation>;
/**
 * Triggered when a draft order is created.
 */
export declare const onDraftOrderCreated: ReturnType<typeof createEventModule<typeof publicOnDraftOrderCreated>>;
/**
 * Triggered when a draft order is deleted.
 */
export declare const onDraftOrderDeleted: ReturnType<typeof createEventModule<typeof publicOnDraftOrderDeleted>>;
/**
 * Triggered when a draft order is updated.
 */
export declare const onDraftOrderUpdated: ReturnType<typeof createEventModule<typeof publicOnDraftOrderUpdated>>;
export { DescriptionLineType, ItemTypeItemType, PaymentOptionType, JurisdictionType, SubscriptionFrequency, AdjustmentType, TaxableAddressType, VatType, PickupDetailsPickupMethod, SourceType, AppliedDiscountDiscountType, DiscountReason, EditingStatus, WeightUnit, PickupMethod, RuleType, FileType, DiscountType, NonDraftableReason, PaymentStatus, FulfillmentStatus, OrderStatus, LineItemQuantityChangeType, ActivityType, AttributionSource, ChannelType, SortOrder, WebhookIdentityType, } from './ecom-v1-draft-order-draft-orders.universal.js';
export { DraftOrder, ItemDetails, ItemDetailsChangeTypeOneOf, Price, PriceDescription, OrderLineItem, ProductName, CatalogReference, DescriptionLine, DescriptionLineValueOneOf, DescriptionLineDescriptionLineValueOneOf, DescriptionLineName, PlainTextValue, Color, FocalPoint, PhysicalProperties, ItemType, ItemTypeItemTypeDataOneOf, ItemTaxFullDetails, LineItemTaxInfo, LineItemTaxBreakdown, DigitalFile, SubscriptionInfo, SubscriptionTitle, SubscriptionDescription, SubscriptionSettings, FreeTrialPeriod, BillingAdjustment, BillingAdjustmentPriceSummary, LocationAndQuantity, TaxableAddress, TaxableAddressTaxableAddressDataOneOf, ExtendedFields, ModifierGroup, TranslatableString, ItemModifier, ItemChangedDetails, ShippingDetails, ShippingDetailsChangeTypeOneOf, V1ShippingInformation, V1DeliveryLogistics, V1DeliveryLogisticsAddressOneOf, AddressWithContact, Address, StreetAddress, AddressLocation, FullAddressContactDetails, VatId, V1PickupDetails, PickupAddress, V1DeliveryTimeSlot, V1ShippingPrice, ShippingRegion, ShippingChangedDetails, BuyerInfo, BuyerInfoIdOneOf, AdditionalFeeDetails, AdditionalFee, TaxDetails, DiscountDetails, AppliedDiscount, AppliedDiscountDiscountSourceOneOf, Coupon, MerchantDiscount, MerchantDiscountMerchantDiscountReasonOneOf, DiscountRule, DiscountRuleName, LineItemDiscount, CreatedBy, CreatedByStringOneOf, PriceSummary, TaxSummary, BalanceSummary, Balance, DraftOrderCommitSettings, InventoryUpdate, RecipientInfoDetails, RecipientInfoDetailsChangeTypeOneOf, RecipientInfoChangedDetails, OrderTaxInfo, OrderTaxBreakdown, BuyerDetails, BuyerDetailsChangeTypeOneOf, BuyerChangedDetails, BillingDetails, BillingDetailsChangeTypeOneOf, BillingChangedDetails, BusinessLocationDetails, BusinessLocationDetailsChangeTypeOneOf, Location, BusinessLocationChangedDetails, CreateDraftOrderRequest, CreateDraftOrderResponse, CalculatedDraftOrder, ShippingOption, DeliveryLogistics, PickupDetails, DeliveryTimeSlot, ShippingPrice, CalculationErrors, CalculationErrorsShippingCalculationErrorOneOf, Details, DetailsKindOneOf, ApplicationError, ValidationError, FieldViolation, SystemError, CarrierErrors, CarrierError, CreateEmptyDraftOrderRequest, CreateEmptyDraftOrderResponse, AddLineItemsToDraftOrderRequest, CatalogReferenceLineItem, CustomLineItem, SecuredMedia, AddLineItemsToDraftOrderResponse, UpdateLineItemsRequest, LineItemChangeDetails, UpdateLineItemsResponse, SetDiscountsRequest, IdAndApplied, SetDiscountsResponse, CreateCustomDiscountsRequest, DiscountOption, DiscountOptionDiscountAmountOneOf, CreateCustomDiscountsResponse, DeleteCustomDiscountsRequest, DeleteCustomDiscountsResponse, SetAdditionalFeesRequest, SetAdditionalFeesResponse, CreateCustomAdditionalFeesRequest, AdditionalFeeOption, CreateCustomAdditionalFeesResponse, DeleteCustomAdditionalFeesRequest, DeleteCustomAdditionalFeesResponse, SetShippingInfoRequest, SetShippingInfoResponse, SetBuyerInfoRequest, SetBuyerInfoResponse, SetRecipientInfoRequest, SetRecipientInfoResponse, SetBillingInfoRequest, SetBillingInfoResponse, UpdateShippingInfoRequest, UpdateShippingInfoResponse, GetDraftOrderRequest, GetDraftOrderResponse, GetOrderDraftabilityStatusRequest, GetOrderDraftabilityStatusResponse, CommitDraftOrderRequest, CommitDraftOrderResponse, Order, CurrencyConversionDetails, Activity, ActivityContentOneOf, CustomActivity, MerchantComment, OrderRefunded, OrderCreatedFromExchange, NewExchangeOrderCreated, LineItemExchangeData, DraftOrderChangesApplied, OrderChange, OrderChangeValueOneOf, LineItemChanges, LineItemQuantityChange, LineItemPriceChange, ManagedLineItem, ManagedDiscount, TranslatedValue, LineItemAmount, ManagedAdditionalFee, TotalPriceChange, ShippingInformationChange, ShippingInformation, SavedPaymentMethod, AuthorizedPaymentCreated, AuthorizedPaymentCaptured, AuthorizedPaymentVoided, RefundInitiated, RefundedPayment, RefundedPaymentKindOneOf, RegularPaymentRefund, GiftCardPaymentRefund, MembershipPaymentRefund, PaymentRefunded, PaymentRefundFailed, RefundedAsStoreCredit, PaymentPending, PaymentPendingPaymentDetailsOneOf, RegularPayment, RegularPaymentPaymentMethodDetailsOneOf, CreditCardDetails, PaymentCanceled, PaymentCanceledPaymentDetailsOneOf, PaymentDeclined, PaymentDeclinedPaymentDetailsOneOf, ReceiptCreated, ReceiptCreatedReceiptInfoOneOf, WixReceipt, ExternalReceipt, ReceiptSent, ReceiptSentReceiptInfoOneOf, V1CreatedBy, V1CreatedByStringOneOf, ChannelInfo, CustomField, V1BalanceSummary, FulfillmentStatusesAggregate, Tags, TagList, CreateOrderFromDraftRequest, OrderCreateSettings, OrderCreateNotifications, CreateOrderFromDraftResponse, DeleteDraftOrderRequest, DeleteDraftOrderResponse, QueryDraftOrdersRequest, CursorQuery, CursorQueryPagingMethodOneOf, Sorting, CursorPaging, QueryDraftOrdersResponse, CursorPagingMetadata, Cursors, UpdateExtendedFieldsRequest, UpdateExtendedFieldsResponse, SetTaxExemptionRequest, SetTaxExemptionResponse, SetBusinessLocationRequest, SetBusinessLocationResponse, DomainEvent, DomainEventBodyOneOf, EntityCreatedEvent, RestoreInfo, EntityUpdatedEvent, EntityDeletedEvent, ActionEvent, MessageEnvelope, IdentificationData, IdentificationDataIdOneOf, BaseEventMetadata, EventMetadata, DraftOrderCreatedEnvelope, DraftOrderDeletedEnvelope, DraftOrderUpdatedEnvelope, AddLineItemsToDraftOrderOptions, CreateCustomDiscountsOptions, CreateCustomAdditionalFeesOptions, SetShippingInfoOptions, SetBuyerInfoOptions, SetRecipientInfoOptions, SetBillingInfoOptions, CommitDraftOrderOptions, CreateOrderFromDraftOptions, DraftOrdersQueryResult, DraftOrdersQueryBuilder, UpdateExtendedFieldsOptions, SetTaxExemptionOptions, SetBusinessLocationOptions, } from './ecom-v1-draft-order-draft-orders.universal.js';
